#include "mainwindow.h"
#include "ui_mainwindow.h"

#undef signals
#include <libappindicator/app-indicator.h>
#define signals public
#include <gtk/gtk.h>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    createAppIndicator();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void appIndicatorToggleWindow(GtkMenuItem *menuItem, gpointer data)
{
    MainWindow *w = static_cast<MainWindow *>(data);
    if (w->isVisible()) {
        w->hide();
        gtk_menu_item_set_label(menuItem, "Show");
    } else {
        w->show();
        gtk_menu_item_set_label(menuItem, "Hide");
    }
}

void MainWindow::createAppIndicator()
{
    if (m_appIndicator)
        return;

    const QString desktop = getenv("XDG_CURRENT_DESKTOP");
    const bool isUnity = (desktop.toLower() == QLatin1String("unity"));

    if (!isUnity)
        return;
    m_appIndicatorMenu = gtk_menu_new();

    m_appIndicatorShowHideMenuItem = gtk_menu_item_new_with_label(qPrintable(tr("Hide")));
    gtk_menu_shell_append(GTK_MENU_SHELL(m_appIndicatorMenu), m_appIndicatorShowHideMenuItem);
    g_signal_connect(m_appIndicatorShowHideMenuItem, "activate",
                     G_CALLBACK(appIndicatorToggleWindow), this);

    m_appIndicatorMenuSeparator = gtk_separator_menu_item_new();
    gtk_menu_shell_append(GTK_MENU_SHELL(m_appIndicatorMenu), m_appIndicatorMenuSeparator);

    m_appIndicatorQuitMenuItem = gtk_menu_item_new_with_label(qPrintable(tr("Quit")));
    gtk_menu_shell_append(GTK_MENU_SHELL(m_appIndicatorMenu), m_appIndicatorQuitMenuItem);
    g_signal_connect(m_appIndicatorQuitMenuItem, "activate",
                     G_CALLBACK(QCoreApplication::quit), NULL);

    gtk_widget_show_all(m_appIndicatorMenu);

    m_appIndicator = app_indicator_new("global-menu-test", "apport", APP_INDICATOR_CATEGORY_OTHER);

    app_indicator_set_status(m_appIndicator, APP_INDICATOR_STATUS_ACTIVE);
    app_indicator_set_menu(m_appIndicator, GTK_MENU(m_appIndicatorMenu));
}
